barang/urls.py
from django.urls import path
from .views import barang_view, semua_barang_view, barang_view_buy, barang_view_review

app_name = 'barang'

urlpatterns = [
    path('<int:id>/buy', barang_view_buy, name='barang-buy'),
    path('<int:id>/review', barang_view_review, name='barang-review'),
    path('<int:id>', barang_view, name='barang-detail'),
    path('all/<str:filter>', semua_barang_view, name='barang-filter'),
    path('all', semua_barang_view, name='barang-all')
]

keranjang/urls.py
from django.urls import path
from .views import keranjang_view, keranjang_add_view, keranjang_update_jumlah_view, keranjang_hapus_view

app_name = 'keranjang'

urlpatterns = [
    path('', keranjang_view, name='keranjang'),
    path('add', keranjang_add_view, name='add'),
    path('update-jumlah', keranjang_update_jumlah_view, name='update-jumlah'),
    path('hapus', keranjang_hapus_view, name='hapus')
]

kupon/urls.py
from django.urls import path
from .views import semua_kupon_view, kupon_api_view

app_name = 'kupon'

urlpatterns = [
    path('', semua_kupon_view, name='semua-kupon'),
    path('api/semua', kupon_api_view, name='kupon-api')
]

onlineshop/urls.py
from django.contrib import admin
from django.urls import path, include
from register import views as regviews

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('barang/', include('barang.urls')),
    path('kategori/', include('kategori.urls')),
    path('kupon/', include('kupon.urls')),
    path('transaksi/', include('transaksi.urls')),
    path('ulasan/', include('ulasan.urls')),
    path('shopadmin/', include('shopadmin.urls')),
    path('', include('landing.urls')),
    path('register/', include('register.urls', namespace='register')),
    path('keranjang/', include('keranjang.urls')),
    path('', include('django.contrib.auth.urls')),
    path('', include('social_django.urls', namespace='social')),
    # path('login/', regviews.login, name='login'),
]

ulasan/urls.py
from django.urls import path
from .views import semua_ulasan_view, add_ulasan_view, delete_ulasan_view

app_name = 'ulasan'

urlpatterns = [
    path('', semua_ulasan_view, name='all-ulasan'),
    path('api/add', add_ulasan_view, name='add'),
    path('api/delete', delete_ulasan_view, name='delete')
]

barang/models.py
from django.db import models
from kategori.models import Kategori


class Barang(models.Model):
    nama = models.CharField(max_length=80)
    harga = models.DecimalField(decimal_places=2, max_digits=30)
    stok = models.PositiveSmallIntegerField()
    deskripsi = models.TextField()
    kategori = models.ForeignKey(
        Kategori, on_delete=models.SET_NULL, related_name="kategori", null=True, blank=True)
    gambar = models.URLField(
        default="https://media.swansonvitamins.com/images/items/master/SW1371.jpg")

barang/views.py
from django.shortcuts import render
from django.db.models import Avg
from .models import Barang
from transaksi.models import Transaksi
from ulasan.models import Ulasan
from transaksi.forms import BeliBarangForm
from ulasan.forms import UlasanForm


def barang_view_buy(request, id):
    if request.method == "POST":
        barang_requested = Barang.objects.get(pk=id)

        beli_form = BeliBarangForm(barang_requested.stok, request.POST)

        success = False
        action = "Transaction"

        if beli_form.is_valid():
            trx = Transaksi()
            trx.nama_pembeli = beli_form.cleaned_data["nama_pembeli"]
            trx.barang = barang_requested
            trx.kupon = beli_form.cleaned_data["kupon"]
            trx.total = barang_requested.harga * \
                beli_form.cleaned_data["jumlah"]
            if trx.kupon:
                if trx.total > trx.kupon.min_harga:
                    trx.total = trx.total * \
                        (100 - trx.kupon.persen_diskon) / 100
            trx.save()

            # decrease item stock
            barang_requested.stok -= beli_form.cleaned_data["jumlah"]
            barang_requested.save()

            # reset form
            beli_form = BeliBarangForm(barang_requested.stok)
            success = True

        ctx_override = {
            "beli_form": beli_form,
            "success": success,
            "action": action
        }

        return barang_view(request, id, ctx_override=ctx_override)
    else:
        return barang_view(request, id)


def barang_view_review(request, id):
    if request.method == "POST":
        barang_requested = Barang.objects.get(pk=id)

        ulasan_form = UlasanForm(request.POST)

        success = False
        action = "Review"

        if ulasan_form.is_valid():
            ulasan_form.save()

            # reset form
            ulasan_form = UlasanForm(initial={"barang": barang_requested})
            success = True

        ctx_override = {
            "ulasan_form": ulasan_form,
            "success": success,
            "action": action
        }

        return barang_view(request, id, ctx_override=ctx_override)
    else:
        return barang_view(request, id)


def barang_view(request, id, ctx_override={}):
    barang_requested = Barang.objects.get(pk=id)

    beli_form = BeliBarangForm(stok=barang_requested.stok)
    ulasan_form = UlasanForm(
        initial={"barang": barang_requested, "nama_pengulas": request.user.username})

    ulasan_barang = Ulasan.objects.filter(barang=barang_requested)
    avg_stars = ulasan_barang.aggregate(Avg("bintang"))

    context = {
        "barang": barang_requested,
        "beli_form": beli_form,
        "avg_rating": avg_stars["bintang__avg"] if avg_stars["bintang__avg"] else 0,
        "num_rating": ulasan_barang.count(),
        "ulasan_barang": ulasan_barang,
        "ulasan_form": ulasan_form
    }

    for k, v in ctx_override.items():
        context[k] = v

    return render(request, "barang/barang.html", context)


def semua_barang_view(request, filter=""):
    filter = filter if filter else request.GET.get("filter", "")
    semua_barang = Barang.objects.filter(nama__contains=filter)
    context = {
        "semua_barang": semua_barang,
        "filter": filter if filter else None
    }
    return render(request, "barang/semua.html", context)

barang/templates/barang/barang.html
{% extends 'base.html' %} {% block content %} {% load static %}
{% load humanize %}
{% load crispy_forms_tags %}
<div class="d-flex flex-column px-4 py-3">
    {% if success %}
    <div class="alert alert-success" role="alert">
    {{action}} Saved!
    </div>
    {% endif %}
  <div class="d-flex flex-column" id="product">
    <div class="image-card">
      <img src="{{barang.gambar}}" class="product-image" />
    </div>
    <div class="product-description px-3 pt-3">
      <h1>{{barang.nama}}</h3>
        <div class="product-detail px-2">
      <h6 class="text-muted">{{barang.kategori.nama}} | {{barang.stok}} pcs</h4>
        <span class="product-price">Rp. {{barang.harga|intcomma}}</span>
      <p class="text-justify">{{barang.deskripsi}}</p>
      {% if user.is_authenticated %}
      <button class="btn btn-primary btn-buy" data-toggle="modal" data-target="#modalBuy">Buy</button>
      <button class="btn btn-primary" id="btn-cart">Add to Cart</button>
      {% endif %}
    </div>
    </div>
  </div>
  <div class="online-card mt-3" id="ulasan-card">
    <div class="d-flex justify-content-center flex-wrap" id="rating-header">
        <h3>ULASAN</h3>
        <div class="d-flex align-items-center px-2">
            <div id="rating-top" data-rateyo-read-only="true" data-rateyo-half-star="true" data-rateyo-rating="{{avg_rating}}"></div>({{num_rating}})
        </div>
    </div>
    <hr>
    <div id="ulasan-container">
        {% if ulasan_barang|length > 0 %}
            <div class="accordion" id="ulasan-accordion">
                {% for ulasan in ulasan_barang %}
                  <div class="card">
                    <div class="card-header" id="heading{{ulasan.id}}">
                    <div class="d-flex justify-content-between align-items-center" data-toggle="collapse" data-target="#collapse{{ulasan.id}}" aria-expanded="false" aria-controls="collapse{{ulasan.id}}">
                      <div class="d-flex">
                      <h4 class="mb-0">
                            {{ulasan.nama_pengulas}}
                        </h4>
                        <button class="btn-delete" data-id={{ulasan.id}}>Delete</button>
                        </div>  
                        <div class="d-flex justify-content-center align-items-center">
                            <div class="rating-ind d-none d-md-block" data-rateyo-read-only="true" data-rateyo-rating={{ulasan.bintang}}></div>
                        </div>
                    </div>
                    </div>

                    <div id="collapse{{ulasan.id}}" class="collapse
                    {% if forloop.counter == 1%}
                    show
                    {% endif %}
                    " aria-labelledby="heading{{ulasan.id}}" data-parent="#ulasan-accordion">
                    <div class="card-body">
                        {{ ulasan.pesan }}
                    </div>
                    </div>
                </div>
                {% endfor %}
            </div>
        {% else %}
        <div class="text-center">
            Tidak ada ulasan!
        </div> 
        {% endif %}
        <div class="d-flex justify-content-center mt-3">
      <button class="btn btn-primary btn-buy" data-toggle="modal" data-target="#modalUlasan">Add Review</button>
        </div>
    </div>
  </div>
</div>
<div class="modal fade" id="modalBuy" tabindex="-1" role="dialog" aria-labelledby="modalBuy" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="modalBuyLabel">Buy {{barang.nama}}</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
                <form action="{% url 'barang:barang-buy' id=barang.id %}" method="POST">
      <div class="modal-body">
              {% csrf_token %}
              {{beli_form|crispy}} 
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <button type="submit" class="btn btn-primary">Buy</button>
      </div>
      </form>
    </div>
  </div>
</div>
<div class="modal fade" id="modalUlasan" tabindex="-1" role="dialog" aria-labelledby="modalBuy" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="modalUlasanLabel">Add Review for {{barang.nama}}</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
                <form id="ulasan-form">
      <div class="modal-body">
              {% csrf_token %}
              {{ulasan_form|crispy}} 
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <button type="submit" class="btn btn-primary">Add</button>
      </div>
      </form>
    </div>
  </div>
</div>
{% endblock %} {% block head %}
<title> {{barang.nama}} | Tk.PePeW Online Shop</title>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/rateYo/2.3.2/jquery.rateyo.min.css">
<link rel="stylesheet" href="{% static 'barang/styles.css' %}" />

{% endblock %}{% block leftsidecontent %}
{% endblock %} {% block rightsidecontent %} {% include 'includes/recommended.html' %} {% endblock %}

{% block js %}
<script src="https://cdnjs.cloudflare.com/ajax/libs/rateYo/2.3.2/jquery.rateyo.min.js"></script>
<script>

function updateUlasan(ulasans) {
  const accordionUlasanHTMLString = (ulasan) => (`
    <div class="card">
        <div class="card-header" id="heading${ulasan.id}">
        <div class="d-flex justify-content-between align-items-center" data-toggle="collapse" data-target="#collapse${ulasan.id}" aria-expanded="false" aria-controls="collapse${ulasan.id}">
                      <div class="d-flex">
                      <h4 class="mb-0">
                            ${ulasan.nama_pengulas}
                        </h4>
                        <button class="btn-delete" data-id=${ulasan.id}>Delete</button>
                        </div>  
            <div class="d-flex justify-content-center align-items-center">
                <div class="rating-ind d-none d-md-block" data-rateyo-read-only="true" data-rateyo-rating=${ulasan.bintang}></div>
            </div>
        </div>
        </div>

        <div id="collapse${ulasan.id}" class="collapse" aria-labelledby="heading${ulasan.id}" data-parent="#ulasan-accordion">
        <div class="card-body">
            ${ ulasan.pesan }
        </div>
        </div>
    </div>
  `)

  const ulasansString = `
    <div class="accordion" id="ulasan-accordion">
      ${ulasans.map(accordionUlasanHTMLString).join("")}
    </div>
  `

  $("#ulasan-container").html(ulasansString)

    $(".rating-ind").rateYo({
    starWidth: "18px"
  });
}

$(function () {
  $("#rating-top").rateYo({
    starWidth: "18px"
  });
  $(".rating-ind").rateYo({
    starWidth: "18px"
  });

  $("#btn-cart").click(async () => {
    const user_id = `{{user.id}}`;
    const barang_id = `{{barang.id}}`;

    const data = {
      user_id,
      barang_id
    }

    const csrftoken = Cookies.get('csrftoken');
    const response = await fetch(`{% url 'keranjang:add' %}`, {
      method: 'POST',
      body: JSON.stringify(data),
      headers: { "X-CSRFToken": csrftoken },
    });

    const result = await response.json();

    const notyf = new Notyf();
    if (result.success) {
      notyf.success(`Barang telah ditambhkan ke keranjang!`);
    } else {
      notyf.error(`Barang gagal ditambahkan ke keranjang!`);
      notyf.error(result.error);
    }
    
  });

    $("#ulasan-form").submit(async (e) => {
      e.preventDefault();
      const f = e.target
      const nama_pengulas = f.nama_pengulas.value
      const bintang = f.bintang.value
      const pesan = f.pesan.value

      const barang_id = `{{barang.id}}`;

      $('#modalUlasan').modal('hide')

    const data = {
      nama_pengulas,
      bintang,
      pesan,
      barang_id
    }

    const csrftoken = Cookies.get('csrftoken');
    const response = await fetch(`{% url 'ulasan:add' %}`, {
      method: 'POST',
      body: JSON.stringify(data),
      headers: { "X-CSRFToken": csrftoken },
    });

    const result = await response.json();

    const notyf = new Notyf();
    if (result.success) {
      notyf.success(`Ulasan telah ditambahkan!`);
      updateUlasan(result.ulasan);
    } else {
      notyf.error(`Ulasan gagal ditambahkan!`);
      notyf.error(result.error);
    }
    
  });

  $(".btn-delete").click(async function() {
      const ulasan_id = this.dataset.id;

    const data = {
      ulasan_id
    }

    const csrftoken = Cookies.get('csrftoken');
    const response = await fetch(`{% url 'ulasan:delete' %}`, {
      method: 'POST',
      body: JSON.stringify(data),
      headers: { "X-CSRFToken": csrftoken },
    });

    const result = await response.json();

    const notyf = new Notyf();
    if (result.success) {
      notyf.success(`Ulasan telah diremove!`);
      updateUlasan(result.ulasan);
    } else {
      notyf.error(`Ulasan gagal diremove!`);
      notyf.error(result.error);
    }
    
  });
});
</script>
{% if success is not None and not success %}
{% if 'Transaction' == action %}
<script>
    $(function() {
        $("#modalBuy").modal()
    })
</script>
{% else %}
<script>
    $(function() {
        $("#modalUlasan").modal()
    })
</script>
{% endif %}
{% endif %}
{% endblock %}

barang/templates/barang/semua.html
{% extends 'base.html' %} {% block content %} {% load static %}
<div class="container">
  <h2 class="text-center">
    Barang {% if filter is not None %} | "{{filter}}" {% endif %}
  </h2>
  <div class="row mt-3">
    {% if semua_barang|length == 0 %}
    <div class="text-center w-100">Tidak ada barang yang sesuai!</div>
    {%endif%} {% for product in semua_barang %}
    <div class="col-sm-3">
      <a href="{% url 'barang:barang-detail' id=product.id %}">
        <div class="online-card text-center all-product-card mb-4">
          <img src="{{product.gambar}}" class="all-product-image" />
          <div class="item-description w-100 px-3">
            <span class="text-muted">{{product.stok}} pcs</span>
            <h4>{{product.nama}}</h4>
          </div>
        </div>
      </a>
    </div>
    {% endfor %}
  </div>
</div>
{% endblock %} {% block head %}
<title>
  {% if filter is not None %} "{{filter}}" | {% endif %} Tk.PePeW Online Shop
</title>
<link rel="stylesheet" href="https://unpkg.com/swiper/css/swiper.min.css" />
<link rel="stylesheet" href="{% static 'barang/styles.css' %}" />

{% endblock %} {% block rightsidecontent %}
<div>{% include 'includes/recommended.html' %}</div>
{% endblock %}